package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type message struct {
	Table
	order string `data:"100"`
	read  string `name:"read" role:"void"`
	done  string `name:"done" role:"void"`
}

func (s message) Create(m *ice.Message, arg ...string) {
	s.Table.Create(m, kit.Simple(arg, model.FROM_USER_UID, m.Option(model.USER_UID))...)
}
func (s message) List(m *ice.Message, arg ...string) {
	s.Select(m, model.TO_USER_UID, m.Option(model.USER_UID)).Table(func(value ice.Maps) {
		switch MessageStatus(kit.Int(value[model.STATUS])) {
		case MessageCreate:
			m.PushButton(s.Read, s.Done)
		case MessageRead:
			m.PushButton(s.Done)
		default:
			m.PushButton()
		}
	}).Action()
}
func (s message) Read(m *ice.Message, arg ...string) {
	s.Table.Update(m, kit.Dict(model.STATUS, MessageRead), m.OptionSimple(model.TO_USER_UID, model.UID)...)
}
func (s message) Done(m *ice.Message, arg ...string) {
	s.Table.Update(m, kit.Dict(model.STATUS, MessageDone), m.OptionSimple(model.TO_USER_UID, model.UID)...)
}

func init() { ice.TeamCtxCmd(message{}) }

type MessageStatus int

const (
	MessageCreate MessageStatus = iota
	MessageRead
	MessageDone
)

var MessageStatusList = map[MessageStatus]string{
	MessageCreate: "create",
	MessageRead:   "read",
	MessageDone:   "done",
}

func (s MessageStatus) String() string { return MessageStatusList[s] }
